import pygame, sys
from pygame.locals import *
from locals import *


class Ball (pygame.sprite.Sprite):
	def __init__(self, spawnPoint):
		self.points = [P(0,0), P(640,480)]
		self.controls = [P(500,0)]
		pygame.sprite.Sprite.__init__(self)
		self.image = pygame.Surface((20,20))
		pygame.draw.circle(self.image, (255,255,255), (10,10), 4)
		self.rect = self.image.get_rect()
		self.rect.center = (spawnPoint)

	def update(self):
		pass


class Enemy (pygame.sprite.Sprite):
	def __init__(self):
		pygame.sprite.Sprite.__init__(self, surface, spawnPoint, pg)
		self.pg = pg
		self.image = surface
		self.rect = surface.get_rect()
		self.rect.center = spawnPoint

	def update(self):
		pass


class Playground():
	def __init(self, size=(640, 480)):
		pygame.init()
		self.size = size
		self.screen =  pygame.display.set_mode(self.size)	
		pygame.display.set_caption('game')
		self.background = pygame.Surface(self.size)
		self.background.fill(C_BG)
		
		self.spriteGroups = []

		self.clock = pygame.time.Clock()
		self.mainloop()

	def mainloop(self):
		self.frameTime = self.clock.tick()
		self.getInput()
		self.drawSprites()
		
	def getInput(self):
		events = pygame.event.get()
		for event in events:
			if event.type == QUIT:
				sys.exit(0)

	def updateSprites(self):
		for spritegroup in self.spriteGroups:
			spritegroup.update()
			spritegroup.draw(self.background)







if __name__ == '__main__':
	screen = pygame.display.set_mode((640,480))
	

	background = pygame.Surface((640,480))
	background.fill((0,0,20))

	screen.blit(background,(0,0))

	pygame.display.flip()

	ball = Ball()
	sprites = pygame.sprite.RenderPlain(ball)


	clock = pygame.time.Clock()
	t = 0
	miliseconds = 0

	p1 = P(640,480)
	p2 = P(500,0)
	p3 = P(0,0)

	while 1:

		miliseconds += clock.tick(120)
		seconds = miliseconds / 1000.0
		t = seconds / 3.0
		events = pygame.event.get()
		for event in events :
			if event.type == QUIT:
				sys.exit(0)

		screen.blit(background,(0,0))
		q1 = bezier(p1,p2,t)
		q2 = bezier(p2,p3,t)
		q =  bezier(q1,q2,t)

		print t, q.x, q.y
		ball.rect = pygame.Rect(q.x, q.y, 20, 20)
		sprites.draw(screen)
		pygame.display.flip()




