class P():
	def __init__(self,x,y):
		self.x = float(x)
		self.y = float(y)
	def __add__(self, p2):
		return P(self.x+p2.x, self.y+p2.y)

	def __sub__(self, p2):
		return P(self.x-p2.x, self.y-p2.y)

	def __mul__(self, c):
		return P(self.x*c, self.y*c)

def quadratic(p0,p1,p2, dx):
	a = ((p0.x*(p1.y-p2.y))+(p0.y*(p2.x-p1.x))+(p1.x*p2.y)-(p2.x*p1.y)) / ((p1.x-p0.x)*(p2.x-p0.x)*(p2.x-p1.x))
	b = (p2.y-p0.y) / (p2.x-p0.x) - (p2.x+p0.x)*a
	c = p0.y-a*p0.x**2-b*p0.x
	
	x = lambda t: t*dx
	y = lambda x: a*x**2+b*x+c
	
	return lambda t: P(x(t),y(x(t)))


def bezier4(p1,p2,p3,p4):

	q1 = lambda t: p1 + (p2 - p1) * t
	q2 = lambda t: p2 + (p3 - p2) * t
	q3 = lambda t: p3 + (p4 - p3) * t

	# p1 + (p2 - p1) * t = q1
	# p2 + (p3 - p2) * t = q2
	# p3 + (p4 - p3) * t = q3

	r1 = lambda t: q1(t) + (q2(t) - q1(t)) * t
	r2 = lambda t: q2(t) + (q3(t) - q2(t)) * t

	# q1 + (q2 - q1) * t = r1
	# q2 + (q3 - q2) * t = r2

	# r1 + (r2 - r1) * t 

	return lambda t: r1(t) + (r2(t) - r1(t)) * t 
			

def bezier2(p1,p2):
	return lambda t: p1+(p2-p1)*t

